#ifndef EVK_VCR_H
#define EVK_VCR_H

#include <QtGui>
#include <QApplication>
#include <QtGui/QWidget>
#include <QTimer>

#include "ui_Theatre.h"
#include "GstPlayer.h"
#include "Usage.h"
#include "CPUControl.h"
#include "utils.h"

#include <unistd.h>
#include <sys/resource.h>
#include <sys/time.h>

class Theatre : public QWidget
{
    Q_OBJECT

public:
    Theatre(QWidget *parent = 0);
    ~Theatre();

private:
    void layout();
    void configure();
	void reset_player();
	void paint_splash(bool fill);
	// void show_usage();
	bool check_bus();
	void update_thread_count();

    GstPlayer* gst_player;
    GstBus* gst_bus;

	Ui::Theatre_VCR ui;
    QTimer* timer;
    QDesktopWidget* qdw;
    QLabel* splash_label;
    QPixmap splash_pixmap;
    QPalette splash_palette;
	QPalette label_palette;

	Usage* usage;
	CPUControl* cpu_control;
	unsigned int num_cores;
	bool extra_threads;

    bool is_stopped;
    bool is_playing;
    bool first_timeout;
    void on_EVK_VCR_clicked();

private slots:
	void play_pause();
	void stop();
	void end();
	void callback();
	void clicked();
	void update_enabled_button();
	void enable_button_clicked();
	void play_accelerated();
	void play_unaccelerated();
	void load_cpu();
	void unload_cpu();
	void start_camera();

};

#endif // EVK_VCR_H
